PC01django/PC01/PC01/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    
    path('votacionesR/', include('votacionesR.urls')),
    path('admin/', admin.site.urls),
]

PC01django/PC01/votacionesR/urls.py
from django.urls import path
from. import views

app_name = 'votacionesR' 

urlpatterns = [
    
    path('', views.index, name='index'),
    
    path('<int:region_id>/',views.detalle, name='detalle'),
    
    path('<int:region_id>/resultados/', views.resultados, name='resultados'),
    
    path('<int:region_id>/voto/', views.votar, name='votar'),
    
]

PC01django/PC01/votacionesR/models.py
from django.db import models

class Region(models.Model):
    nregion= models.CharField(max_length=200)
   

class Candidato(models.Model):
    fkregion = models.ForeignKey(Region, on_delete=models.CASCADE)
    ncandidato = models.CharField(max_length=200)
    nucandidato = models.CharField(max_length=200)
    pcandidato= models.CharField(max_length=200)
    
    votos = models. IntegerField(default=0)

PC01django/PC01/votacionesR/views.py
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import get_object_or_404, render
from django.urls import reverse

from .models import Candidato, Region

def index(request):
    ultima_region_lista = Region.objects.order_by('-nregion')[:5]
    context = {'ultima_region_lista': ultima_region_lista}
    return render(request, 'index.html', context)

def detalle (request, region_id):
    region = get_object_or_404(Region, pk=region_id)
    return render(request, 'detalle.html', {'region': region})

def votar (request, region_id):
    region = get_object_or_404(Region, pk=region_id)
    try:
        selected_candidato = region.candidato_set.get(pk=request.POST['candidato'])
    except (KeyError, Candidato.DoesNotExist):
        return render(request, 'detalle.html', {
            'region' : region,
            'error_message' : "No has seleccionado nada",
        })
    else:
        selected_candidato.votos += 1
        selected_candidato.save()
        return HttpResponseRedirect(reverse('votacionesR:resultados', args=(region.id,)))
    

def resultados(request, region_id):
    region = get_object_or_404(Region, pk=region_id)
    return render(request, 'resultados.html', {'region': region})

PC01django/PC01/votacionesR/templates/detalle.html
<h1>{{ region.nregion}}</h1>

<ul>
    {% for candidato in region.candidato_set.all %}
        <li>{{ candidato.ncandidato }} -- {{ candidato.nucandidato}} -- {{ candidato.pcandidato}} -- {{ candidato.votos}}  -- voto{{ candidato.votos| pluralize }}</li>
    {% endfor%}
</ul>

<a href="{% url 'votacionesR:resultados' region.id %}">Votar de nuevo?</a>
<a href="{% url 'votacionesR:index' %}">Ver Regiones</a>

PC01django/PC01/votacionesR/templates/index.html
<h1>Votaciones Regionales</h1>

{% if ultima_region_lista %}
    <ul>
        {% for region in ultima_region_lista %}
            <li>
                <a href="/votacionesR/{{ region.id }}/">{{ region.nregion }}</a>
            </li>
        {% endfor %}

    </ul>
{% else %}
    <p>No hay registros</p>
{% endif %}

PC01django/PC01/votacionesR/templates/resultados.html
<h1>{{ region.nregion }}</h1>

{% if error_message %} <p><strong>{{ error_message }}</strong></p>{% endif %}

<form action="{% url 'votacionesR:votar' region.id %}" method="POST">
    {% csrf_token %}
    {% for candidato in region.candidato_set.all %}
        <input type="radio" name="candidato" id="candidato{{ forloop.counter }}" value="{{candidato.id}}">
        <label for="candidato{{ forloop.counter }}">{{ candidato.ncandidato }}</label><br>
    {% endfor %}
    <input type="submit" value="Votar">
</form>
<br/>
<a href="{% url 'votacionesR:index' %}">Ver Regiones</a>